'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PrimaryHeader = require('../PrimaryHeader');

var _PrimaryHeader2 = _interopRequireDefault(_PrimaryHeader);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function BreadcrumbListItem(props) {
    return _react2.default.createElement(
        'li',
        null,
        _react2.default.createElement(
            'span',
            {
                className: 'section-link',
                onClick: props.changeBreadCrumbState,
                role: 'button'
            },
            props.breadcrumb.label
        ),
        _react2.default.createElement('i', { className: 'fa fa-chevron-right' })
    );
}

BreadcrumbListItem.propTypes = {
    changeBreadCrumbState: _propTypes2.default.func,
    breadcrumb: _propTypes2.default.shape({
        label: _propTypes2.default.string.isRequired
    }).isRequired
};

BreadcrumbListItem.defaultProps = {
    changeBreadCrumbState: undefined
};

var Breadcrumb = function (_Component) {
    _inherits(Breadcrumb, _Component);

    function Breadcrumb() {
        _classCallCheck(this, Breadcrumb);

        return _possibleConstructorReturn(this, (Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).apply(this, arguments));
    }

    _createClass(Breadcrumb, [{
        key: 'changeBreadCrumbState',
        value: function changeBreadCrumbState(breadcrumb) {
            if (this.props.changeBreadCrumbState) {
                this.props.changeBreadCrumbState(breadcrumb.state, breadcrumb.params);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var breadcrumbs = this.props.breadcrumbItems;

            if (!breadcrumbs.length) {
                return null;
            }

            return _react2.default.createElement(
                _styles.BreadcrumbContainer,
                null,
                _react2.default.createElement(
                    'ul',
                    null,
                    breadcrumbs.map(function (breadcrumb, index) {
                        if (index === breadcrumbs.length - 1) {
                            return _react2.default.createElement(
                                'li',
                                { key: breadcrumb.label },
                                _react2.default.createElement(_PrimaryHeader2.default, {
                                    headerText: breadcrumb.label
                                })
                            );
                        }

                        return _react2.default.createElement(BreadcrumbListItem, {
                            key: breadcrumb.label,
                            breadcrumb: breadcrumb,
                            changeBreadCrumbState: function changeBreadCrumbState(e) {
                                return _this2.changeBreadCrumbState(breadcrumb, e);
                            }
                        });
                    })
                )
            );
        }
    }]);

    return Breadcrumb;
}(_react.Component);

Breadcrumb.propTypes = {
    changeBreadCrumbState: _propTypes2.default.func,
    breadcrumbItems: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        label: _propTypes2.default.string.isRequired,
        current: _propTypes2.default.bool
    })).isRequired
};

Breadcrumb.defaultProps = {
    changeBreadCrumbState: undefined
};

exports.default = Breadcrumb;