'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _CheckboxTreeFilter = require('./styles/CheckboxTreeFilter');

var _ToggleComponent = require('../ToggleComponent');

var _ToggleComponent2 = _interopRequireDefault(_ToggleComponent);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

var _CheckboxTree = require('../CheckboxTree');

var _CheckboxTree2 = _interopRequireDefault(_CheckboxTree);

var _SimpleSearch = require('../SimpleSearch');

var _SimpleSearch2 = _interopRequireDefault(_SimpleSearch);

var _colorCodes = require('../colorCodes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var snakeCaseCapitalize = function snakeCaseCapitalize(strn) {
    if (strn) {
        var str = strn.toLowerCase();
        var newStrArr = str.split('_');
        var isUnderscorePresent = str.indexOf('_') > -1;
        var newStr = '';
        for (var i = 0; i < newStrArr.length; i++) {
            newStr += newStrArr[i].charAt(0).toUpperCase() + newStrArr[i].substring(1) + (isUnderscorePresent ? ' ' : '');
        }
        return newStr;
    }
    return '';
};

var filterNodes = function filterNodes(nodes, value, root, expanded) {
    _lodash2.default.each(nodes, function (node) {
        var nodeName = node.value.replace(/_+?/g, '').toLowerCase().indexOf(value.trim().toLowerCase());
        if (Object.prototype.hasOwnProperty.call(node, 'children')) {
            filterNodes(node.children, value, false, expanded);
            node.children = _lodash2.default.filter(node.children, function (child) {
                return child.search;
            });
            if (node.children.length > 0) {
                node.search = true;
                expanded.push(node.value);
            } else {
                node.search = false;
            }
        } else if (nodeName > -1) {
            node.search = true;
        } else {
            node.search = false;
        }
    });
    if (root) {
        return _lodash2.default.filter(nodes, function (node) {
            return node.search;
        });
    }
};

var CheckboxTreeFilter = function (_React$Component) {
    _inherits(CheckboxTreeFilter, _React$Component);

    function CheckboxTreeFilter(props) {
        _classCallCheck(this, CheckboxTreeFilter);

        var _this = _possibleConstructorReturn(this, (CheckboxTreeFilter.__proto__ || Object.getPrototypeOf(CheckboxTreeFilter)).call(this));

        _this.state = {
            checked: props.checked || [],
            expanded: props.expanded || [],
            search: props.searchValue || '',
            nodes: props.nodes,
            showAllFilters: false
        };
        _this.nodes = _lodash2.default.cloneDeep(props.nodes);
        _this.searchThreshold = props.searchThreshold || 2;
        _lodash2.default.bindAll(_this, 'onSearchType', 'isFilterActive', 'resetFilters', 'clearFilter', 'onFilterChange', 'onFilterExpand', 'toggleFilter', 'showFilters');
        return _this;
    }

    _createClass(CheckboxTreeFilter, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!_lodash2.default.isEqual(this.state.nodes, nextProps.nodes) || nextProps.checked && !_lodash2.default.isEqual(this.state.checked, nextProps.checked)) {
                this.nodes = _lodash2.default.cloneDeep(nextProps.nodes);
                this.setState({
                    nodes: nextProps.nodes,
                    checked: nextProps.checked
                });
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.state.checked.length !== prevState.checked.length) {
                if (this.props.onChange) {
                    this.props.onChange(this.state.checked, this.props.name);
                }
            }
        }
    }, {
        key: 'onFilterChange',
        value: function onFilterChange(checked) {
            this.setState({ checked: checked });
        }
    }, {
        key: 'onSearchType',
        value: function onSearchType(value) {
            if (value.length <= 0) {
                this.setState({ nodes: this.nodes });
            } else if (value.length > this.searchThreshold) {
                var expanded = [];
                this.expanded = this.state.expanded;
                this.checked = this.state.checked;
                var newNodes = filterNodes(_lodash2.default.cloneDeep(this.nodes), value, true, expanded);
                this.setState({ nodes: newNodes, expanded: expanded });
            }
        }
    }, {
        key: 'onFilterExpand',
        value: function onFilterExpand(expanded) {
            this.setState({ expanded: expanded });
        }
    }, {
        key: 'clearFilter',
        value: function clearFilter(index) {
            var checked = _lodash2.default.cloneDeep(this.state).checked;
            checked.splice(index, 1);
            this.setState({
                checked: checked,
                showAllFilters: checked.length <= this.props.showFilterOption ? false : this.state.showAllFilters
            });
        }
    }, {
        key: 'resetFilters',
        value: function resetFilters() {
            this.setState({ checked: [], showAllFilters: false });
        }
    }, {
        key: 'isFilterActive',
        value: function isFilterActive() {
            return this.state.checked.length > 0;
        }
    }, {
        key: 'toggleFilter',
        value: function toggleFilter() {
            this.setState(function (prevState) {
                return {
                    showAllFilters: !prevState.showAllFilters
                };
            });
        }
    }, {
        key: 'showFilters',
        value: function showFilters(initShowFilters) {
            var _this2 = this;

            var countCheckItems = this.state.checked.length;

            if (countCheckItems) {
                var filters = null;
                if (countCheckItems > initShowFilters) {
                    filters = _react2.default.createElement(
                        _CheckboxTreeFilter.Filter,
                        { onClick: this.toggleFilter },
                        this.state.showAllFilters ? 'Show Less' : 'Show More (' + (countCheckItems - initShowFilters) + ')'
                    );
                }

                return _react2.default.createElement(
                    _CheckboxTreeFilter.ChipContainer,
                    { className: 'selected-values-container' },
                    this.state.checked.map(function (filter, index) {
                        var display = index < initShowFilters ? 'inline-block' : _this2.state.showAllFilters ? 'inline-block' : 'none';
                        return _react2.default.createElement(
                            'div',
                            null,
                            _react2.default.createElement(
                                _CheckboxTreeFilter.Chip,
                                {
                                    key: filter,
                                    style: {
                                        display: display,
                                        whiteSpace: 'nowrap'
                                    },
                                    onClick: function onClick() {
                                        _this2.clearFilter(index);
                                    }
                                },
                                _react2.default.createElement(
                                    'span',
                                    { style: { paddingRight: '5px' } },
                                    snakeCaseCapitalize(filter)
                                ),
                                _react2.default.createElement('i', {
                                    className: 'fa fa-times',
                                    'aria-hidden': 'true'
                                })
                            )
                        );
                    }),
                    filters
                );
            }
            return null;
        }
    }, {
        key: 'render',
        value: function render() {
            return _react2.default.createElement(
                _CheckboxTreeFilter.CheckboxTreeFilterContainer,
                { className: this.props.className },
                _react2.default.createElement(
                    _ToggleComponent2.default,
                    {
                        label: this.props.label,
                        name: this.props.name,
                        resetFilters: this.resetFilters,
                        activeFilter: this.isFilterActive(),
                        'default': this.props.defaultShow
                    },
                    this.props.type === 'checkbox' && _react2.default.createElement(
                        _Card2.default,
                        {
                            width: 'auto',
                            minWidth: '100%',
                            position: 'absolute',
                            padding: '10px',
                            boxShadow: 'rgba(208, 208, 208, 0.5) 1px 0px 6px 0px',
                            zIndex: '1',
                            className: 'checkbox-toggle-content'
                        },
                        this.showFilters(this.props.showFilterOption),
                        this.props.includeSearch && _react2.default.createElement(_SimpleSearch2.default, {
                            width: '100%',
                            height: '23px',
                            padding: '0px',
                            className: this.props.searchClassName,
                            placeholder: this.props.placeholder,
                            backgroundColor: _colorCodes.colors.whiteText,
                            value: this.state.search,
                            onChange: this.onSearchType,
                            fontSize: '12px'
                        }),
                        _react2.default.createElement(_CheckboxTree2.default, {
                            nodes: this.state.nodes,
                            showNodeIcon: false,
                            expanded: this.state.expanded,
                            checked: this.state.checked,
                            onCheck: this.onFilterChange,
                            onExpand: this.onFilterExpand,
                            height: this.props.treeHeight,
                            className: 'check-box-tree-container'
                        })
                    )
                )
            );
        }
    }]);

    return CheckboxTreeFilter;
}(_react2.default.Component);

exports.default = CheckboxTreeFilter;


CheckboxTreeFilter.propTypes = {
    checked: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
    expanded: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
    searchValue: _propTypes2.default.string.isRequired,
    nodes: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        label: _propTypes2.default.string.isRequired,
        value: _propTypes2.default.string.isRequired,
        className: _propTypes2.default.string,
        children: _propTypes2.default.array
    })).isRequired,
    searchThreshold: _propTypes2.default.number,
    name: _propTypes2.default.string.isRequired,
    showFilterOption: _propTypes2.default.number,
    className: _propTypes2.default.string.isRequired,
    label: _propTypes2.default.string.isRequired,
    defaultShow: _propTypes2.default.bool.isRequired,
    type: _propTypes2.default.string.isRequired,
    includeSearch: _propTypes2.default.bool.isRequired,
    searchClassName: _propTypes2.default.string.isRequired,
    placeholder: _propTypes2.default.string.isRequired,
    treeHeight: _propTypes2.default.string.isRequired,
    onChange: _propTypes2.default.func
};

CheckboxTreeFilter.defaultProps = {
    onChange: undefined,
    searchThreshold: 2,
    showFilterOption: 2
};