"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PrimaryBtn = exports.SecondaryBtn = exports.SearchInput = undefined;

var _templateObject = _taggedTemplateLiteral(["\n    color : ", ";\n    font-size: ", ";\n    display: ", ";\n    border: ", ";\n    background-color: ", ";\n    width: ", ";\n    max-width: ", ";\n    height: ", ";\n    margin: ", ";\n    padding: ", ";\n    border-radius: ", ";\n    box-shadow: ", ";\n    &:focus { outline: none; }\n    &:focus::-webkit-input-placeholder{ color: transparent; }\n    &:focus::-moz-placeholder { color: transparent; }\n    &:focus:-ms-input-placeholder { color: transparent; }\n    &.active {\n        border-color: ", ";\n    }\n"], ["\n    color : ", ";\n    font-size: ", ";\n    display: ", ";\n    border: ", ";\n    background-color: ", ";\n    width: ", ";\n    max-width: ", ";\n    height: ", ";\n    margin: ", ";\n    padding: ", ";\n    border-radius: ", ";\n    box-shadow: ", ";\n    &:focus { outline: none; }\n    &:focus::-webkit-input-placeholder{ color: transparent; }\n    &:focus::-moz-placeholder { color: transparent; }\n    &:focus:-ms-input-placeholder { color: transparent; }\n    &.active {\n        border-color: ", ";\n    }\n"]),
    _templateObject2 = _taggedTemplateLiteral(["\npadding:", ";\nmargin: ", ";\ntop: ", ";\nwidth:", ";\nheight:", ";\nbackground-color: ", ";\nborder-radius: ", ";\nposition : ", ";\nborder: 1px solid ", ";\ncolor: ", ";\nfont-size:", ";\nfont-family: Arial;\nvertical-align: middle;\n&:focus {\n    outline: none;\n}\n&:disabled, &[disabled] {\n    background-color: ", ";\n    border: 1px solid ", ";\n    color: ", ";\n}\n"], ["\npadding:", ";\nmargin: ", ";\ntop: ", ";\nwidth:", ";\nheight:", ";\nbackground-color: ", ";\nborder-radius: ", ";\nposition : ", ";\nborder: 1px solid ", ";\ncolor: ", ";\nfont-size:", ";\nfont-family: Arial;\nvertical-align: middle;\n&:focus {\n    outline: none;\n}\n&:disabled, &[disabled] {\n    background-color: ", ";\n    border: 1px solid ", ";\n    color: ", ";\n}\n"]);

var _styledComponents = require("styled-components");

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _colorCodes = require("../colorCodes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var SearchInput = exports.SearchInput = _styledComponents2.default.input(_templateObject, function (props) {
    return props.color || _colorCodes.colors.searchInputTextColor;
}, function (props) {
    return props.fontSize || '13px';
}, function (props) {
    return props.display || "block";
}, function (props) {
    return props.border || '1px solid ' + _colorCodes.colors.inputBorder;
}, function (props) {
    return props.backgroundColor || 'rgba(234,234,234,0.6)';
}, function (props) {
    return props.width || '100%';
}, function (props) {
    return props.maxWidth || "none";
}, function (props) {
    return props.height || '40px';
}, function (props) {
    return props.margin || '0px';
}, function (props) {
    return props.padding || '7px';
}, function (props) {
    return props.borderRadius || '4px';
}, function (props) {
    return props.boxShadow || 'inset 0 1px 3px 0 rgba(63,63,63,0.15)';
}, _colorCodes.colors.btnBorder);

var SecondaryBtn = exports.SecondaryBtn = _styledComponents2.default.button(_templateObject2, function (props) {
    return props.padding || '8px 15px';
}, function (props) {
    return props.margin || '0px';
}, function (props) {
    return props.top || '0px';
}, function (props) {
    return props.width || 'auto';
}, function (props) {
    return props.height || 'auto';
}, _colorCodes.colors.whiteText, function (props) {
    return props.borderRadius || '4px';
}, function (props) {
    return props.position || 'relative';
}, _colorCodes.colors.btnBorder, _colorCodes.colors.brandBlue, function (props) {
    return props.fontSize || '12px';
}, _colorCodes.colors.greyBorder, _colorCodes.colors.inputBorder, _colorCodes.colors.inputBorder);

var PrimaryBtn = exports.PrimaryBtn = _styledComponents2.default.button(_templateObject2, function (props) {
    return props.padding || '8px 15px';
}, function (props) {
    return props.margin || '0px';
}, function (props) {
    return props.top || '0px';
}, function (props) {
    return props.width || 'auto';
}, function (props) {
    return props.height || 'auto';
}, _colorCodes.colors.brandBlue, function (props) {
    return props.borderRadius || '4px';
}, function (props) {
    return props.position || 'relative';
}, _colorCodes.colors.brandBlue, _colorCodes.colors.whiteText, function (props) {
    return props.fontSize || '12px';
}, _colorCodes.colors.greyBorder, _colorCodes.colors.inputBorder, _colorCodes.colors.inputBorder);