'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _FilterComponent = require('./styles/FilterComponent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterComponent = function (_React$Component) {
    _inherits(FilterComponent, _React$Component);

    function FilterComponent(props) {
        _classCallCheck(this, FilterComponent);

        var _this = _possibleConstructorReturn(this, (FilterComponent.__proto__ || Object.getPrototypeOf(FilterComponent)).call(this, props));

        _this.state = {
            showMore: false
        };
        _this.toggleShowMore = _this.toggleShowMore.bind(_this);
        return _this;
    }

    _createClass(FilterComponent, [{
        key: 'toggleShowMore',
        value: function toggleShowMore() {
            this.setState(function (prev) {
                return { showMore: !prev.showMore };
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var _props = this.props,
                onFilterReset = _props.onFilterReset,
                onFilterSubmit = _props.onFilterSubmit,
                onFilterClear = _props.onFilterClear,
                expand = _props.expand,
                filterChips = _props.filterChips,
                className = _props.className,
                maxChips = _props.maxChips;

            var filterCount = filterChips.length;
            var shownFilterChips = maxChips && !this.state.showMore ? filterChips.slice(0, maxChips) : filterChips;
            return _react2.default.createElement(
                _FilterComponent.FilterComponentContainer,
                {
                    className: className + ' ' + (expand ? 'open' : '')
                },
                shownFilterChips && shownFilterChips.length > 0 ? _react2.default.createElement(
                    _FilterComponent.ChipsContainer,
                    null,
                    this.props.filterLabel && _react2.default.createElement(
                        _FilterComponent.Label,
                        null,
                        this.props.filterLabel
                    ),
                    _react2.default.createElement(
                        _FilterComponent.Chips,
                        { chipsHeight: this.props.chipsHeight },
                        shownFilterChips.map(function (filter) {
                            return _react2.default.createElement(
                                _FilterComponent.Chip,
                                { key: filter.type + '_' + filter.key },
                                _react2.default.createElement(
                                    'span',
                                    null,
                                    filter.value
                                ),
                                _react2.default.createElement('i', {
                                    className: 'fa fa-times',
                                    'aria-hidden': 'true',
                                    onClick: function onClick() {
                                        return onFilterClear(filter);
                                    }
                                })
                            );
                        }),
                        maxChips && maxChips < filterCount && _react2.default.createElement(
                            _FilterComponent.ShowMore,
                            { onClick: this.toggleShowMore },
                            this.state.showMore ? 'show less' : 'show more'
                        )
                    )
                ) : null,
                _react2.default.createElement(
                    _FilterComponent.FiltersContainer,
                    null,
                    _react2.default.createElement(
                        _FilterComponent.Filters,
                        null,
                        _react2.default.Children.map(this.props.children, function (filterItem) {
                            return _react2.default.createElement(
                                _FilterComponent.Filter,
                                null,
                                filterItem
                            );
                        })
                    ),
                    _react2.default.createElement(
                        _FilterComponent.FilterActions,
                        null,
                        _react2.default.createElement(
                            _FilterComponent.ApplyButton,
                            {
                                className: 'apply-button',
                                type: 'button',
                                onClick: onFilterSubmit
                            },
                            this.props.submitText
                        ),
                        _react2.default.createElement(
                            _FilterComponent.ResetButton,
                            {
                                className: 'reset-button',
                                type: 'button',
                                onClick: onFilterReset
                            },
                            this.props.resetText
                        )
                    )
                )
            );
        }
    }]);

    return FilterComponent;
}(_react2.default.Component);

FilterComponent.defaultProps = {
    filterChips: [],
    expand: false,
    className: '',
    filterLabel: '',
    submitText: 'Apply',
    resetText: 'Reset',
    maxChips: null,
    chipsHeight: null
};

FilterComponent.propTypes = {
    /**
     * expands/collapses the filter component
     */
    expand: _propTypes.PropTypes.bool,
    /**
     * class for the component
     */
    className: _propTypes.PropTypes.string,
    /**
     * function to call on Apply clicked
     */
    onFilterSubmit: _propTypes.PropTypes.func.isRequired,
    /**
     * Filters to be shown
     */
    children: _propTypes.PropTypes.element.isRequired,
    /**
     * filter by label
     */
    filterLabel: _propTypes.PropTypes.string,
    /**
     * Submit button text
     */
    submitText: _propTypes.PropTypes.string,
    /**
     * Reset button text
     */
    resetText: _propTypes.PropTypes.string,
    /**
     * function to call when a chip is cleared
     */
    onFilterClear: _propTypes.PropTypes.func.isRequired,
    /**
     * function to call on Reset clicked
     */
    onFilterReset: _propTypes.PropTypes.func.isRequired,
    /**
     * chips to be shown
     */
    filterChips: _propTypes.PropTypes.arrayOf(_propTypes.PropTypes.string),
    /**
     * Max chips to be shown
     */
    maxChips: _propTypes.PropTypes.number,
    /**
     * Max chips to be shown
     */
    chipsHeight: _propTypes.PropTypes.string
};

exports.default = FilterComponent;