'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _FilterComponent = require('./FilterComponent');

var _FilterComponent2 = _interopRequireDefault(_FilterComponent);

var _CheckboxTreeFilter = require('../CheckboxTreeFilter');

var _CheckboxTreeFilter2 = _interopRequireDefault(_CheckboxTreeFilter);

var _Slider = require('../Slider');

var _Slider2 = _interopRequireDefault(_Slider);

var _ToggleComponent = require('../ToggleComponent');

var _ToggleComponent2 = _interopRequireDefault(_ToggleComponent);

var _Card = require('../Card');

var _Card2 = _interopRequireDefault(_Card);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FilterComponentWrapper = function (_React$Component) {
    _inherits(FilterComponentWrapper, _React$Component);

    function FilterComponentWrapper(props) {
        _classCallCheck(this, FilterComponentWrapper);

        var _this = _possibleConstructorReturn(this, (FilterComponentWrapper.__proto__ || Object.getPrototypeOf(FilterComponentWrapper)).call(this, props));

        _this.state = _extends({
            filterChips: []
        }, props.appliedFilters);
        _this.getInput = _this.getInput.bind(_this);
        _this.updateFilters = _this.updateFilters.bind(_this);
        _this.onFilterClear = _this.onFilterClear.bind(_this);
        _this.onFilterReset = _this.onFilterReset.bind(_this);
        _this.onFilterSubmit = _this.onFilterSubmit.bind(_this);
        _this.state.filterChips = _this.props.templateParams.map(function (param) {
            return param.name;
        }).reduce(function (list, key) {
            return [].concat(_toConsumableArray(list), _toConsumableArray(_this.getFilterContent(key)));
        }, []);
        return _this;
    }

    _createClass(FilterComponentWrapper, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            this.setState(_extends({}, newProps.appliedFilters));
        }
    }, {
        key: 'onFilterClear',
        value: function onFilterClear(filterChip) {
            this.updateState(function (prevState) {
                var selectedFilter = prevState[filterChip.type];
                return _defineProperty({}, filterChip.type, Array.isArray(selectedFilter) ? selectedFilter.filter(function (filter) {
                    return Array.isArray(filterChip.key) ? !(filterChip.key.indexOf(filter) > -1) : filter !== filterChip.key;
                }) : undefined);
            });
        }
    }, {
        key: 'onFilterReset',
        value: function onFilterReset() {
            var state = this.props.templateParams.reduce(function (obj, param) {
                obj[param.name] = undefined;
                return obj;
            }, {});
            state.filterChips = [];
            this.setState(state);
            if (this.props.onFilterReset) {
                this.props.onFilterReset(state);
            }
        }
    }, {
        key: 'onFilterSubmit',
        value: function onFilterSubmit() {
            var _this2 = this;

            if (this.props.onFilterSubmit) {
                this.props.onFilterSubmit(this.props.templateParams.reduce(function (obj, param) {
                    obj[param.name] = _this2.state[param.name];
                    return obj;
                }, {}));
            }
        }
    }, {
        key: 'getFilterCount',
        value: function getFilterCount() {
            return this.filterChips.length;
        }
    }, {
        key: 'getInput',
        value: function getInput(param) {
            switch (param.type) {
                case 'toggleCheckboxTree':
                    return this.getToggleCheckboxTree(param);
                case 'toggleSlider':
                    return this.getToggleSlider(param);
                case 'component':
                    return this.getComponent(param);
                default:
                    return null;
            }
        }
    }, {
        key: 'getFilterContent',
        value: function getFilterContent(key) {
            var param = this.props.templateParams.find(function (item) {
                return item.name === key;
            });
            var selectedFilter = this.state[key];

            if (param.chipsParser) {
                var parsed = param.chipsParser(selectedFilter);
                if (parsed && Array.isArray(parsed)) {
                    return parsed.map(function (item) {
                        return {
                            key: item.key,
                            value: item.value,
                            type: key
                        };
                    });
                }
                return [];
            }

            return selectedFilter ? Array.isArray(selectedFilter) ? selectedFilter.map(function (filter) {
                return {
                    key: filter,
                    value: param.displayContent ? param.displayContent(filter) : filter,
                    type: key
                };
            }) : [{
                key: selectedFilter,
                value: param.displayContent ? param.displayContent(selectedFilter) : selectedFilter,
                type: key
            }] : [];
        }
    }, {
        key: 'getToggleCheckboxTree',
        value: function getToggleCheckboxTree(param) {
            var _this3 = this;

            return param.name && _react2.default.createElement(_CheckboxTreeFilter2.default, _extends({}, param.props, {
                key: param.name,
                type: 'checkbox',
                onChange: function onChange(checked) {
                    return _this3.updateState(_defineProperty({}, param.name, checked));
                },
                checked: this.state[param.name] || [],
                includeSearch: param.includeSearch,
                searchClassName: 'toggle-filter-search',
                placeholder: param.searchPlaceholder,
                label: param.label,
                nodes: param.nodes
            }));
        }
    }, {
        key: 'getToggleSlider',
        value: function getToggleSlider(param) {
            var _this4 = this;

            var value = this.state[param.name];
            return param.name && _react2.default.createElement(
                _ToggleComponent2.default,
                {
                    key: param.name,
                    label: param.label,
                    name: param.name,
                    resetFilters: function resetFilters() {
                        return _this4.updateState(_defineProperty({}, param.name, undefined));
                    },
                    activeFilter: this.state[param.name],
                    openedClass: 'toggle-open-carrot',
                    closedClass: 'toggle-closed-carrot'
                },
                _react2.default.createElement(
                    _Card2.default,
                    {
                        minWidth: '100%',
                        position: 'absolute',
                        padding: '10px 20px',
                        boxShadow: 'rgba(208, 208, 208, 0.5) 1px 0px 6px 0px',
                        zIndex: '1',
                        className: 'toggle-slider'
                    },
                    _react2.default.createElement(_Slider2.default, _extends({}, param.props, {
                        range: param.range,
                        min: param.min,
                        max: param.max,
                        steps: param.steps,
                        onChange: function onChange(values) {
                            _this4.updateState(_defineProperty({}, param.name, Array.isArray(values) ? {
                                min: values[0],
                                max: values[1]
                            } : values));
                        },
                        value: (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object' ? [value.min, value.max] : value
                    }))
                )
            );
        }

        /**
         *
         * Can accept external Component.
         * The input component should accept `onChange` and `value` props
         * and handle as needed.
         */

    }, {
        key: 'getComponent',
        value: function getComponent(param) {
            var _this5 = this;

            var Component = param.Component,
                name = param.name;

            return name && Component && _react2.default.createElement(Component, {
                value: this.state[name],
                onChange: function onChange(value) {
                    return _this5.updateState(_defineProperty({}, name, value));
                }
            });
        }
    }, {
        key: 'updateFilters',
        value: function updateFilters() {
            var _this6 = this;

            var filterChips = this.props.templateParams.map(function (param) {
                return param.name;
            }).reduce(function (list, key) {
                return [].concat(_toConsumableArray(list), _toConsumableArray(_this6.getFilterContent(key)));
            }, []);
            this.setState({ filterChips: filterChips });

            if (this.props.onFilterChange) {
                this.props.onFilterChange(this.props.templateParams.reduce(function (obj, param) {
                    obj[param.name] = _this6.state[param.name];
                    return obj;
                }, {}));
            }
        }
    }, {
        key: 'updateState',
        value: function updateState(state) {
            if (state) {
                this.setState(state, this.updateFilters);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var templateParams = this.props.templateParams || [];
            var filterComponentProps = {
                filterChips: this.state.filterChips,
                onFilterClear: this.onFilterClear,
                onFilterReset: this.onFilterReset,
                onFilterSubmit: this.onFilterSubmit
            };

            return _react2.default.createElement(
                _FilterComponent2.default,
                _extends({}, this.props, filterComponentProps),
                Array.isArray(templateParams) && templateParams.length && templateParams.map(this.getInput)
            );
        }
    }]);

    return FilterComponentWrapper;
}(_react2.default.Component);

FilterComponentWrapper.defaultProps = {
    expand: false,
    className: '',
    onFilterChange: function onFilterChange() {},
    onFilterReset: function onFilterReset() {}
};

FilterComponentWrapper.propTypes = {
    /**
     * expands/collapses the filter component
     */
    expand: _propTypes.PropTypes.bool,
    /**
     * class for the component
     */
    className: _propTypes.PropTypes.string,
    /**
     * function to call on Apply clicked
     */
    onFilterSubmit: _propTypes.PropTypes.func.isRequired,
    /**
     * function to call on Apply clicked
     */
    onFilterReset: _propTypes.PropTypes.func,
    /**
     * function to call when any filter is changed
     */
    onFilterChange: _propTypes.PropTypes.func,
    /**
     * Filters to be preselected
     */
    appliedFilters: _propTypes.PropTypes.element.isRequired,
    /**
     * Template params used to render filter elements
     */
    templateParams: _propTypes.PropTypes.arrayOf(_propTypes.PropTypes.object).isRequired
};

exports.default = FilterComponentWrapper;