'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _icon = require('../StyleComponents/icon');

var _icon2 = _interopRequireDefault(_icon);

var _Buttons = require('../Buttons');

var _style = require('./style.js');

var _colorCodes = require('../colorCodes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by sarunathan.s
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var loaderMinWidth = 60;
var loaderMaxWidth = 110;

var Grid = function (_React$Component) {
    _inherits(Grid, _React$Component);

    function Grid(props) {
        _classCallCheck(this, Grid);

        var _this = _possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).call(this, props));

        _this.state = {
            selectedCheckBox: {},
            showDetails: false,
            detailsLeftPx: null,
            selectedId: '',
            columnLength: _this.props.selectRow ? _this.props.column.length + 1 : _this.props.column.length
        };
        return _this;
    }

    _createClass(Grid, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.state.detailsLeftPx == null) {
                this.setState({
                    detailsLeftPx: this.computeDetailLeft()
                });
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            this.props.selectRow && this.resetSelectedHandler(nextProps.data); // When data changes if the new id is not in render remove from selected array
            if (!_lodash2.default.isEqual(this.props.data, nextProps.data)) {
                this.disableDetailsView();
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (!_lodash2.default.isEqual(prevState.selectedCheckBox, this.state.selectedCheckBox) && this.props.checkBoxOnchange) {
                this.props.checkBoxOnchange(Object.keys(this.state.selectedCheckBox));
            }
        }
    }, {
        key: 'getDataUniqueIds',
        value: function getDataUniqueIds(data) {
            var _this2 = this;

            return data.reduce(function (arr, obj) {
                arr[_lodash2.default.get(obj, _this2.props.id)] = 'selected';
                return arr;
            }, {});
        }
    }, {
        key: 'sortableColumn',
        value: function sortableColumn(v, k) {
            if (this.props.sortableColumn && this.props.sortableColumn.indexOf(v.name) !== -1) {
                var icon = void 0;
                if (this.state.sortApplied && this.state.sortApplied[v.name] && this.state.sortApplied[v.name] == 'ascending') {
                    icon = _react2.default.createElement(_icon2.default, {
                        className: 'fa fa-sort-asc clickable',
                        width: '15px',
                        height: '15px'
                    });
                } else if (this.state.sortApplied && this.state.sortApplied[v.name] && this.state.sortApplied[v.name] == 'descending') {
                    icon = _react2.default.createElement(_icon2.default, {
                        className: 'fa fa-sort-desc clickable',
                        width: '15px',
                        height: '15px'
                    });
                } else {
                    icon = _react2.default.createElement(_icon2.default, {
                        className: 'fa fa-sort clickable',
                        width: '15px',
                        height: '15px'
                    });
                }

                return _react2.default.createElement(
                    _style.TheadCell,
                    {
                        key: k,
                        className: 'clickable',
                        onClick: this.sortHandler.bind(this, v.name)
                    },
                    v.name,
                    icon
                );
            }
            return _react2.default.createElement(
                _style.TheadCell,
                { key: k },
                v.name
            );
        }
    }, {
        key: 'sortHandler',
        value: function sortHandler(key) {
            var _this3 = this;

            this.setState(function (state) {
                var sortApplied = {};

                if (state.sortApplied && !state.sortApplied[key]) {
                    sortApplied[key] = 'descending';
                    _this3.props.sortOnchange && _this3.props.sortOnchange(sortApplied);
                    return {
                        sortApplied: sortApplied
                    };
                }

                if (state.sortApplied && state.sortApplied[key] == 'ascending') {
                    sortApplied[key] = 'descending';
                } else {
                    sortApplied[key] = 'ascending';
                }
                _this3.props.sortOnchange && _this3.props.sortOnchange(sortApplied);
                return {
                    sortApplied: sortApplied
                };
            });
        }
    }, {
        key: 'resetSelectedHandler',
        value: function resetSelectedHandler(data) {
            var ids = this.getDataUniqueIds(data);
            this.setState(function (prev) {
                Object.keys(prev.selectedCheckBox).filter(function (id) {
                    return !ids[id];
                }).forEach(function (id) {
                    delete prev.selectedCheckBox[id];
                });
                return prev;
            });
        }
    }, {
        key: 'selectAllCheckbox',
        value: function selectAllCheckbox(e) {
            var isSelect = e.target.checked;
            var ids = this.getDataUniqueIds(this.props.data);
            this.tableRef.querySelectorAll('.child-checkbox').forEach(function (o) {
                o.checked = e.target.checked;
            });

            this.setState(function (prev) {
                if (!isSelect) ids = {}; // return empty ids to state on deselect;
                return _extends({}, prev, {
                    selectedCheckBox: _extends({}, ids)
                });
            });
        }
    }, {
        key: 'computeDetailLeft',
        value: function computeDetailLeft() {
            var ths = this.tableRef.querySelectorAll('th');
            var width = 0;
            var colToShow = this.props.colToShow || 1;
            if (this.props.selectRow) ++colToShow;
            [].concat(_toConsumableArray(Array(colToShow))).forEach(function (v, i) {
                width += ths[i].offsetWidth;
            });
            width = this.tableRef.offsetWidth / 2 - width;
            return width + 'px';
        }
    }, {
        key: 'enableDetailsView',
        value: function enableDetailsView(id) {
            this.setState({
                showDetails: true,
                selectedId: id
            });
        }
    }, {
        key: 'disableDetailsView',
        value: function disableDetailsView() {
            this.setState({
                showDetails: false,
                selectedId: ''
            });
        }
    }, {
        key: 'chechBoxClickHandler',
        value: function chechBoxClickHandler(id) {
            this.setState(function (prev) {
                var prevState = _lodash2.default.cloneDeep(prev);
                if (prevState.selectedCheckBox[id]) {
                    delete prevState.selectedCheckBox[id];
                } else {
                    prevState.selectedCheckBox[id] = 'selected';
                }
                return prevState;
            });
        }
    }, {
        key: 'renderTableCell',
        value: function renderTableCell(obj, k, col, i) {
            if ((_lodash2.default.get(obj, col.key) || !col.key) && this.props.enableDetailsView && col.clickable) {
                return _react2.default.createElement(
                    _style.TbodyCell,
                    {
                        key: i,
                        className: 'clickable',
                        onClick: this.enableDetailsView.bind(this, _lodash2.default.get(obj, col.key))
                    },
                    this.props.cellRenderer ? this.props.cellRenderer(_lodash2.default.get(obj, col.key), {
                        row: k,
                        column: i
                    }) : _lodash2.default.get(obj, col.key)
                );
            }

            if (_lodash2.default.get(obj, col.key) || !col.key) {
                return _react2.default.createElement(
                    _style.TbodyCell,
                    { key: i },
                    this.props.cellRenderer ? this.props.cellRenderer(_lodash2.default.get(obj, col.key), {
                        row: k,
                        column: i
                    }) : _lodash2.default.get(obj, col.key)
                );
            }

            return _react2.default.createElement(
                _style.TbodyCell,
                { key: i },
                this.renderLoader()
            );
        }
    }, {
        key: 'renderLoader',
        value: function renderLoader() {
            var width = Math.random() * (loaderMaxWidth - loaderMinWidth) + loaderMinWidth;
            return _react2.default.createElement(_style.Loader /* width={width+'px'} */, null);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this4 = this;

            return _react2.default.createElement(
                _style.GridContainer,
                { left: this.state.detailsLeftPx },
                _react2.default.createElement(
                    'div',
                    {
                        className: 'grid-container',
                        style: { width: '200%' },
                        ref: function ref(el) {
                            _this4.tableRef = el;
                        }
                    },
                    _react2.default.createElement(
                        _style.Table,
                        null,
                        _react2.default.createElement(
                            'thead',
                            null,
                            _react2.default.createElement(
                                'tr',
                                null,
                                this.props.selectRow && _react2.default.createElement(
                                    _style.TheadCell,
                                    { className: 'checkbox-td' },
                                    _react2.default.createElement('input', {
                                        type: 'checkbox',
                                        onClick: this.selectAllCheckbox.bind(this)
                                    })
                                ),
                                this.props.column.map(this.sortableColumn.bind(this))
                            )
                        ),
                        _react2.default.createElement(
                            'tbody',
                            null,
                            this.props.data.map(function (obj, k) {
                                return _react2.default.createElement(
                                    'tr',
                                    {
                                        className: _this4.state.selectedId === _lodash2.default.get(obj, _this4.props.id) ? 'active' : '',
                                        key: _lodash2.default.get(obj, _this4.props.id)
                                    },
                                    _this4.props.selectRow && _react2.default.createElement(
                                        _style.TbodyCell,
                                        { className: 'checkbox-td' },
                                        _react2.default.createElement('input', {
                                            className: 'child-checkbox',
                                            type: 'checkbox',
                                            onClick: _this4.chechBoxClickHandler.bind(_this4, _lodash2.default.get(obj, _this4.props.id))
                                        })
                                    ),
                                    _this4.props.column.map(_this4.renderTableCell.bind(_this4, obj, k))
                                );
                            }),
                            this.props.data.length === 0 && _react2.default.createElement(
                                _style.NoDataTr,
                                null,
                                _react2.default.createElement(
                                    'td',
                                    { colSpan: this.state.columnLength },
                                    'No data to display'
                                )
                            )
                        )
                    ),
                    _react2.default.createElement(
                        _style.GridDetail,
                        {
                            className: this.state.showDetails ? 'grid-detail' : ''
                        },
                        _react2.default.createElement(
                            _style.DetailHeader,
                            null,
                            _react2.default.createElement(
                                _Buttons.SecondaryBtn,
                                {
                                    cursor: 'pointer',
                                    padding: '6px 10px',
                                    textALign: 'left',
                                    width: '151px',
                                    height: '30px',
                                    onClick: this.disableDetailsView.bind(this)
                                },
                                _react2.default.createElement(_icon2.default, {
                                    className: 'fa fa-angle-left clickable',
                                    color: _colorCodes.colors.brandBlue,
                                    style: { fontSize: '15px' },
                                    width: '10px',
                                    height: '9px'
                                }),
                                'Back to dashboard'
                            ),
                            this.props.detailViewHeader
                        ),
                        _react2.default.createElement(
                            _style.DetailContent,
                            null,
                            this.state.showDetails ? this.props.detailViewContent : ''
                        )
                    ),
                    _react2.default.createElement('div', { style: { clear: 'both' } })
                )
            );
        }
    }]);

    return Grid;
}(_react2.default.Component);

exports.default = Grid;