'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _Inputs = require('../FormElements/Inputs');

var _colorCodes = require('../colorCodes');

var _SearchWithOptions = require('./styles/SearchWithOptions');

var _reactClickOutside = require('react-click-outside');

var _reactClickOutside2 = _interopRequireDefault(_reactClickOutside);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Created by manoraj.k on 17/08/17.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var SearchWithOptions = function (_React$Component) {
    _inherits(SearchWithOptions, _React$Component);

    function SearchWithOptions(props) {
        _classCallCheck(this, SearchWithOptions);

        var _this = _possibleConstructorReturn(this, (SearchWithOptions.__proto__ || Object.getPrototypeOf(SearchWithOptions)).call(this, props));

        _this.state = {
            value: '',
            showSearchList: false,
            showUndo: false
        };
        _this.initialValue = props.value;
        _lodash2.default.bindAll(_this, 'onFocus', 'onChange', 'onKeyUp', 'undoSearch', 'getUndoState');
        return _this;
    }

    _createClass(SearchWithOptions, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            if (this.props.value) {
                this.setState({ value: this.props.value });
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (this.props.value !== nextProps.value) {
                this.initialValue = nextProps.value;
                this.setState({ value: nextProps.value });
            }
        }
    }, {
        key: 'onChange',
        value: function onChange(e) {
            var value = e.target.value;
            this.setState({ value: value });
        }
    }, {
        key: 'getUndoState',
        value: function getUndoState(value) {
            if (value && this.initialValue == value || !value && this.initialValue !== value) {
                return true;
            }
            return false;
        }
    }, {
        key: 'onFocus',
        value: function onFocus() {
            if (this.state.value.length > 0) {
                this.setState({ showSearchList: true });
            }
        }
    }, {
        key: 'onKeyUp',
        value: function onKeyUp() {
            if (this.state.value.length > 0) {
                this.setState({ showSearchList: true });
            } else {
                this.setState({ showSearchList: false });
            }
        }
    }, {
        key: 'searchTypeClick',
        value: function searchTypeClick(option) {
            this.setState({ showSearchList: false });
            this.props.onOptionSearch && this.props.onOptionSearch(option, this.state.value);
        }
    }, {
        key: 'undoSearch',
        value: function undoSearch() {
            this.setState({ showSearchList: false, value: '' });
            this.props.onOptionSearch && this.props.onOptionSearch({}, '');
        }
    }, {
        key: 'handleClickOutside',
        value: function handleClickOutside() {
            this.setState({ showSearchList: false });
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                {
                    style: { position: 'relative' },
                    className: this.props.className || ''
                },
                _react2.default.createElement(_Inputs.SearchInput, {
                    width: this.props.width,
                    height: this.props.height,
                    padding: this.props.padding,
                    className: 'simple-search-input ' + (this.state.value ? 'active' : ''),
                    boxShadow: this.props.boxShadow || undefined,
                    border: this.props.border || undefined,
                    ref: function ref(input) {
                        _this2.searchInput = input;
                    },
                    backgroundColor: this.props.backgroundColor || undefined,
                    value: this.state.value,
                    type: 'text',
                    onChange: this.onChange,
                    placeholder: this.props.placeholder,
                    onFocus: this.onFocus,
                    onKeyUp: this.onKeyUp
                }),
                !this.getUndoState(this.state.value) && _react2.default.createElement(_SearchWithOptions.SimpleSearchIcon, {
                    className: 'fa fa-search ' + (this.state.value ? 'active-icon-color' : 'inprogress-icon-color')
                }),
                this.getUndoState(this.state.value) && _react2.default.createElement(_SearchWithOptions.SimpleSearchIcon, {
                    className: 'fa fa-undo active-icon-color',
                    onClick: this.undoSearch
                }),
                this.state.showSearchList && this.props.searchOptions && this.props.searchOptions.length && _react2.default.createElement(
                    _SearchWithOptions.SearchTypeList,
                    {
                        className: this.props.listClassName || ''
                    },
                    this.props.searchOptions.map(function (option, index) {
                        return _react2.default.createElement(
                            'li',
                            {
                                key: index,
                                className: 'search-type-list-item',
                                onClick: _this2.searchTypeClick.bind(_this2, option)
                            },
                            _react2.default.createElement(
                                'span',
                                null,
                                _react2.default.createElement(
                                    'span',
                                    { className: 'id-type' },
                                    option.label,
                                    ':',
                                    ' '
                                ),
                                _react2.default.createElement(
                                    'strong',
                                    { className: 'search-value' },
                                    _this2.state.value
                                )
                            )
                        );
                    })
                )
            );
        }
    }]);

    return SearchWithOptions;
}(_react2.default.Component);

exports.default = (0, _reactClickOutside2.default)(SearchWithOptions);