'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SimpleSearchBig = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Inputs = require('../FormElements/Inputs');

var _Inputs2 = _interopRequireDefault(_Inputs);

var _styles = require('./styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function createComponent(WrapperComponent, IconComponent) {
    return function (_React$Component) {
        _inherits(_class, _React$Component);

        function _class(props) {
            _classCallCheck(this, _class);

            var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

            _this.state = {
                value: '',
                showUndo: false
            };
            _this.initialValue = props.value;
            _lodash2.default.bindAll(_this, 'searchOnClick', 'onChange', 'getUndoState', 'undoSearch', 'handleKeyPress');
            return _this;
        }

        _createClass(_class, [{
            key: 'componentWillMount',
            value: function componentWillMount() {
                if (this.props.value) {
                    this.setState({ value: this.props.value });
                }
            }
        }, {
            key: 'componentWillReceiveProps',
            value: function componentWillReceiveProps(nextProps) {
                if (this.props.value !== nextProps.value) {
                    this.initialValue = nextProps.value;
                    this.setState({ value: nextProps.value });
                }
            }
        }, {
            key: 'onChange',
            value: function onChange(e) {
                this.setState({ value: e.target.value });
                this.props.onChange && this.props.onChange(e.target.value);
            }
        }, {
            key: 'getUndoState',
            value: function getUndoState(value) {
                if (!this.props.showUndo) {
                    return false;
                }
                if (value && this.initialValue === value || !value && this.initialValue !== value) {
                    return true;
                }
                return false;
            }
        }, {
            key: 'searchOnClick',
            value: function searchOnClick(event) {
                event.preventDefault();
                var searchText = _reactDom2.default.findDOMNode(this.searchInput).value;
                this.props.onSearchEnter && this.props.onSearchEnter(searchText);
            }
        }, {
            key: 'handleKeyPress',
            value: function handleKeyPress(e) {
                var value = e.target.value;
                if (e.key === 'Enter' && value !== this.initialValue) {
                    this.props.onSearchEnter && this.props.onSearchEnter(e.target.value);
                }
            }
        }, {
            key: 'undoSearch',
            value: function undoSearch() {
                this.initialValue = '';
                this.setState({ value: '' });
                this.props.onSearchEnter && this.props.onSearchEnter('');
            }
        }, {
            key: 'render',
            value: function render() {
                var _this2 = this;

                return _react2.default.createElement(
                    WrapperComponent,
                    { noData: !this.getUndoState(this.state.value) },
                    _react2.default.createElement(IconComponent, {
                        className: 'fa fa-search',
                        onClick: this.searchOnClick
                    }),
                    _react2.default.createElement(_Inputs2.default, {
                        ref: function ref(input) {
                            _this2.searchInput = input;
                        },
                        value: this.state.value,
                        type: 'text',
                        onChange: this.onChange,
                        placeholder: this.props.placeholder,
                        onKeyPress: this.handleKeyPress
                    }),
                    this.getUndoState(this.state.value) && _react2.default.createElement(IconComponent, {
                        className: 'fa fa-times-circle',
                        onClick: this.undoSearch
                    })
                );
            }
        }]);

        return _class;
    }(_react2.default.Component);
}

var SimpleSearch = createComponent(_styles.SimpleSearchContainer, _styles.StyledIcon);
var SimpleSearchBig = createComponent(_styles.SimpleSearchContainerBig, _styles.StyledIconBig);

exports.default = SimpleSearch;
exports.SimpleSearchBig = SimpleSearchBig;